// ACM 2006
// Problem A. Automaton optimization
// Sergio A. Fjodorov

//     

{$apptype console}

{ $define DEBUG_PRINT}

uses
  StrUtils;

const
  MAX = 1000000;

type
  PSeq = ^TSeq;
  TSeq = array[-MAX..MAX] of boolean;

var
  a, b: TSeq;
  p, pa, pb: PSeq;
  t: array of integer;
  i, j, n: integer;
  s, f, l: integer;
  center: integer;
  m, mm: integer;

  procedure Print(From, Count: integer);
  var
    i: integer;
  begin
    Write(IfThen(pa^[From], '1', '0'));
    for i := 1 to Count - 1 do
      Write(' ', IfThen(pa^[From + i], '1', '0'));
    WriteLn;
  end;

begin
  Assign(input, 'input.txt');
  Assign(output, 'output.txt');
  Reset(input);
  Rewrite(output);

  // 
  Read(n);
  SetLength(t, n);
  for i := 0 to n - 1 do
    Read(t[i]);
  Read(s, f, l);

  //     ,     
  m := t[0];
  mm := t[0];
  for i := 1 to High(t) do begin
    if m > t[i] then m := t[i];
    if mm < t[i] then mm := t[i];
  end;
  center := (m + mm) div 2;

  Dec(f, center);
  Dec(m, center);
  Dec(mm, center);
  for i := 0 to High(t) do
    a[t[i] - center] := true;

  // , 
  pa := @a;
  pb := @b;
  for i := 2 to s do begin
{$ifdef DEBUG_PRINT}
    Print(-s + 1, 2 * s);
{$endif}

    Dec(m);
    Inc(mm);
    FillChar(pb^, sizeof(TSeq), false);
    for j := m to mm do
      pb[j] := pa^[j - 1] xor pa^[j + 1];

    p := pa;
    pa := pb;
    pb := p;
  end;

{$ifdef DEBUG_PRINT}
  Print(-s + 1, 2 * s);
  WriteLn;
{$endif}

  // 
  Print(f, l);

  Close(input);
  Close(output);
end.