// ACM 2006
// Problem A. Automaton optimization
// Sergio A. Fjodorov

// - ,       S  F
//   

{$apptype console}

uses
  Math;

type
  TBoolenDynArray = array of boolean;

  function Between(X, A, B: integer): boolean;
  begin
    Result := (A <= X) and (X <= B);
  end;

  function Count2(N: integer): integer;
  begin
    Result := 0;
    while (N > 0) and (N mod 2 = 0) do begin
      Inc(Result);
      N := N div 2;
    end;
  end;

  function PrepareC2(N: integer; FromK, ToK: integer): TBoolenDynArray;
  var
    i: integer;
    cnt2: integer;
    t: integer;
  begin
    SetLength(Result, ToK - FromK + 1);
    for i := 0 to High(Result) do
      Result[i] := false;

    cnt2 := 0;
    t := 1;
    for i := 0 to Min(ToK, N) do begin
      Inc(cnt2, Count2(t));
      Dec(cnt2, Count2(i));
      if i >= FromK then
        Result[i - FromK] := (cnt2 = 0);
      t := N - i;
    end;
  end;

var
  t: array[1..2000] of integer;
  tc: integer;
  tt: integer;
  w: array[-1000..1000] of boolean;
  a: array[0..2000] of boolean;
  i, j, n: integer;
  s, f, l: integer;
  p: integer;
  f1, f2, m1, m2: integer;
  cc: TBoolenDynArray;
  ccFromIdx, ccToIdx: integer;
  minp, maxp: integer;

begin
  Assign(input, 'input.txt');
  Assign(output, 'output.txt');
  Reset(input);
  Rewrite(output);

  FillChar(w, sizeof(w), false);
  tc := 0;

  // 
  Read(n);
  for i := 0 to n - 1 do begin
    Read(tt);
    if w[tt] then continue;
    w[tt] := true;
    Inc(tc);
    t[tc] := tt;
  end;
  Read(s, f, l);

  Dec(s); //   - s = 0

  m1 := t[1];
  m2 := t[1];
  for i := 2 to tc do begin
    if m1 > t[i] then m1 := t[i];
    if m2 < t[i] then m2 := t[i];
  end;

  f1 := f;
  f2 := f + l - 1;

  //  
  maxp := Max(Abs(f1 - m2), Abs(f2 - m1));

  //  
  if
    Between(f1, m1, m2) or Between(f2, m1, m2) or
    Between(m1, f1, f2) or Between(m2, f1, f2)
  then
    minp := 0
  else
    minp := Min(Abs(f1 - m2), Abs(f2 - m1));

  // cc - C(s, minp..maxp) mod 2 = 0
  ccFromIdx := (s - maxp) div 2;
  ccToIdx := (s - minp) div 2;
  cc := PrepareC2(s, ccFromIdx, ccToIdx);

  for i := 1 to tc do begin
    for j := 0 to l - 1 do begin
      p := f + j - t[i]; //   
      if p < 0 then p := -p;

      if (p > s) then continue; //   - 
      if (s - p) mod 2 <> 0 then continue; //   - 

      p := (s - p) div 2;
      a[j] := a[j] xor cc[p - ccFromIdx];
    end;
  end;

  Write(integer(a[0]));
  for i := 1 to l - 1 do
    Write(' ', integer(a[i]));
  WriteLn;

  Close(input);
  Close(output);
end.
